//--------------------
// Name: Tez City RPG Datablocks
// Author: Tezuni
//--------------------

%error = forceRequiredAddOn("player_no_jet");

if(%error)
{
	if(%error == $error::addOn_disabled)
	{
		playerNoJet.uiName = "";
	}
	
	if(%error == $error::addOn_notFound)
	{
		return;
	}
}

$TezRP_temp::loadedDatablocks = true;

datablock triggerData(TezRPBuildZoneTriggerData)
{
	tickPeriodMS = 500;
	
	parent = 0;
};

datablock triggerData(TezRPInputTriggerData)
{
	tickPeriodMS = 500;
	
	parent = 0;
};

datablock fxDTSBrickData(TezRPSmallBuildZoneBrickData : brick16x16FData)
{
	iconName = "Add-Ons/TezMods_CityRP/BuildZoneIcons/16x16LotIcon";
	category = "TezMods";
	subCategory = "Tez City RP";
	
	uiName = "Small Build Zone";
	
	TezRPBrickType = 1;
	TezRPBrickAdmin = false;
	
	triggerDatablock = TezRPBuildZoneTriggerData;
	triggerSize = "15.6 15.6 128";
	trigger = 0;
	
	initialPrice = 300;
	taxAmount = 10;
};

datablock fxDTSBrickData(TezRPHalfSmallBuildZoneBrickData : brick16x32FData)
{
	iconName = "Add-Ons/TezMods_CityRP/BuildZoneIcons/16x32LotIcon";
	category = "TezMods";
	subCategory = "Tez City RP";
	
	uiName = "Half-Small Build Zone";
	
	TezRPBrickType = 1;
	TezRPBrickAdmin = false;
	
	triggerDatablock = TezRPBuildZoneTriggerData;
	triggerSize = "15.6 31.6 128";
	trigger = 0;
	
	initialPrice = 600;
	taxAmount = 15;
};

datablock fxDTSBrickData(TezRPMediumBuildZoneBrickData : brick32x32FData)
{
	iconName = "Add-Ons/TezMods_CityRP/BuildZoneIcons/32x32LotIcon";
	category = "TezMods";
	subCategory = "Tez City RP";
	
	uiName = "Medium Build Zone";
	
	TezRPBrickType = 1;
	TezRPBrickAdmin = false;
	
	triggerDatablock = TezRPBuildZoneTriggerData;
	triggerSize = "31.6 31.6 128";
	trigger = 0;
	
	initialPrice = 1200;
	taxAmount = 20;
};

datablock fxDTSBrickData(TezRPLargeBuildZoneBrickData : brick64x64FData)
{
	iconName = "Add-Ons/TezMods_CityRP/BuildZoneIcons/64x64LotIcon";
	category = "TezMods";
	subCategory = "Tez City RP";
	
	uiName = "Large Build Zone";
	
	TezRPBrickType = 1;
	TezRPBrickAdmin = false;
	
	triggerDatablock = TezRPBuildZoneTriggerData;
	triggerSize = "63.6 63.6 128";
	trigger = 0;
	
	initialPrice = 6000;
	taxAmount = 30;
};

datablock fxDTSBrickData(TezRPMediumBuildZoneNoTaxBrickData : brick32x32FData)
{
	iconName = "Add-Ons/TezMods_CityRP/BuildZoneIcons/32x32ZoneIcon";
	category = "TezMods";
	subCategory = "Tez City RP";
	
	uiName = "Medium 0 Tax";
	
	TezRPBrickType = 1;
	TezRPBrickAdmin = false;
	
	triggerDatablock = TezRPBuildZoneTriggerData;
	triggerSize = "31.6 31.6 128";
	trigger = 0;
	
	initialPrice = 25000;
	taxAmount = 0;
};

datablock fxDtsBrickData(TezRPPersonalSpawnBrickData : brickSpawnPointData)
{
	category = "TezMods";
	subCategory = "Tez City RP";
	
	uiName = "Personal Spawn";
	
	specialBrickType = "";
	
	TezRPBrickType = 3;
	TezRPBrickAdmin = false;
	
	spawnData = "personalSpawn";
};

datablock fxDTSBrickData(TezRPBankBrickData : brick2x4FData)
{
	category = "TezMods";
	subCategory = "Tez City RP Admin";
	
	uiName = "Bank Brick";
	
	TezRPBrickType = 2;
	TezRPBrickAdmin = true;
	
	triggerDatablock = TezRPInputTriggerData;
	triggerSize = "2 4 1";
	trigger = 0;
};

datablock fxDTSBrickData(TezRPINFOBrickData : brick2x4FData)
{
	category = "TezMods";
	subCategory = "Tez City RP Admin";
	
	uiName = "Info Brick";
	
	TezRPBrickType = 2;
	TezRPBrickAdmin = true;
	
	triggerDatablock = TezRPInputTriggerData;
	triggerSize = "2 4 1";
	trigger = 0;
};

datablock fxDTSBrickData(TezRPATMBrickData : brick2x4FData)
{
	category = "TezMods";
	subCategory = "Tez City RP";
	
	uiName = "ATM Brick";
	
	TezRPBrickType = 2;
	TezRPBrickAdmin = false;
	
	triggerDatablock = TezRPInputTriggerData;
	triggerSize = "2 4 1";
	trigger = 0;
};

datablock fxDTSBrickData(TezRPPoliceBrickData : brick2x4FData)
{
	category = "TezMods";
	subCategory = "Tez City RP Admin";
	
	uiName = "Police Brick";
	
	TezRPBrickType = 2;
	TezRPBrickAdmin = true;
	
	triggerDatablock = TezRPInputTriggerData;
	triggerSize = "2 4 1";
	trigger = 0;
};

datablock fxDTSBrickData(TezRPBountyBrickData : brick2x4FData)
{
	category = "TezMods";
	subCategory = "Tez City RP Admin";
	
	uiName = "Bounty Brick";
	
	TezRPBrickType = 2;
	TezRPBrickAdmin = true;
	
	triggerDatablock = TezRPInputTriggerData;
	triggerSize = "2 4 1";
	trigger = 0;
};

datablock fxDTSBrickData(TezRPRealEstateBrickData : brick2x4FData)
{
	category = "TezMods";
	subCategory = "Tez City RP Admin";
	
	uiName = "Real Estate Brick";
	
	TezRPBrickType = 2;
	TezRPBrickAdmin = true;
	
	triggerDatablock = TezRPInputTriggerData;
	triggerSize = "2 4 1";
	trigger = 0;
};

datablock fxDtsBrickData(TezRPJailSpawnBrickData : brickSpawnPointData)
{
	category = "TezMods";
	subCategory = "Tez City RP Admin";
	
	uiName = "Jail Spawn";
	
	specialBrickType = "";
	
	TezRPBrickType = 3;
	TezRPBrickAdmin = true;
	
	spawnData = "jailSpawn";
};

datablock fxDTSBrickData(TezRPTreeData : brickPineTreeData)
{
	category = "TezMods";
	subCategory = "Resources";
	
	uiName = "Lumber Tree";
	
	Lumber = 50;
	
	TezRPBrickType = 4;
	TezRPBrickAdmin = true;
};

datablock PlayerData(PlayerNoJet : PlayerStandardArmor)
{
	canJet = 0;
	rechargeRate = 0;
	// Blup..Blup..
	uiName = "No-Jet Player";
	showEnergyBar = true;
};

function PlayerNoJet::damage(%this,%obj,%sourceobj,%position,%damage,%damagetype)
{
	%curenergy = %obj.getDamageLevel();

	Parent::damage(%this,%obj,%sourceobj,%position,%damage,%damagetype);

	if(%obj.getEnergyLevel() < 60)
	{
		%obj.emote(PainMidImage,1);
	}

	if(%obj.getEnergyLevel() < 20)
	{
		%obj.emote(PainHighImage,1);
	}

	%obj.setEnergyLevel(100 - %curenergy);
}

datablock ShapeBaseImageData(godImage)
{
shapeFile = "base/data/shapes/empty.dts";
emap = false;

mountPoint[0] = $LeftHandSLot;
mountPoint[1] = $RightHandSLot;

stateName[0]					= "Ready";
stateTransitionOnTimeout[0]		= "FireA";
stateTimeoutValue[0]			= 0.01;

stateName[1]					= "FireA";
stateTransitionOnTimeout[1]		= "Done";
stateWaitForTimeout[1]			= True;
stateTimeoutValue[1]			= 99999999;
stateEmitter[1]					= WandEmitterB;
stateEmitterTime[1]				= 99999999;

stateName[2]					= "Done";
stateScript[2]					= "onDone";
};

datablock ShapeBaseImageData(godImageTwo)
{
shapeFile = "base/data/shapes/empty.dts";
emap = false;

mountPoint[0] = $LeftHandSLot;
mountPoint[1] = $RightHandSLot;

stateName[0]					= "Ready";
stateTransitionOnTimeout[0]		= "FireA";
stateTimeoutValue[0]			= 0.01;

stateName[1]					= "FireA";
stateTransitionOnTimeout[1]		= "Done";
stateWaitForTimeout[1]			= True;
stateTimeoutValue[1]			= 0.1;
stateEmitter[1]					= WandEmitterB;
stateEmitterTime[1]				= 0.1;

stateName[2]					= "Done";
stateScript[2]					= "onDone";
};

function godImageTwo::onDone(%this,%obj,%sLot)
{
%obj.unMountImage(%sLot);
}

function godImage::onDone(%this,%obj,%sLot)
{
%obj.unMountImage(%sLot);
}

// ----------------------------- //

datablock ShapeBaseImageData(healSpellImage)
{
shapeFile = "base/data/shapes/empty.dts";
emap = false;

mountPoint = $HeadSLot;

stateName[0]					= "Ready";
stateTransitionOnTimeout[0]		= "FireA";
stateTimeoutValue[0]			= 0.01;

stateName[1]					= "FireA";
stateTransitionOnTimeout[1]		= "Done";
stateWaitForTimeout[1]			= True;
stateTimeoutValue[1]			= 0;
stateEmitter[1]					= WandEmitterB;
stateEmitterTime[1]				= 1;

stateName[2]					= "Done";
stateScript[2]					= "onDone";
};

////////////////////////

datablock AudioDescription(AudioFar3d)
{
volume = 1.0;
isLooping= true;

is3D = true;
ReferenceDistance= 20.0;
MaxDistance= 1024.0;
type = $SimAudioType;
};

if(!isObject(TezRP_16x16))
{
	datablock decalData(TezRP_16x16)
	{
		textureName = "Add-Ons/TezMods_CityRP/BuildZoneIcons/16x16LotIcon";
		preload = true;
	};
}

if(!isObject(TezRP_16x32))
{
	datablock decalData(TezRP_16x32)
	{
		textureName = "Add-Ons/TezMods_CityRP/BuildZoneIcons/16x32LotIcon";
		preload = true;
	};
}

if(!isObject(TezRP_32x32))
{
	datablock decalData(TezRP_32x32)
	{
		textureName = "Add-Ons/TezMods_CityRP/BuildZoneIcons/32x32LotIcon";
		preload = true;
	};
}

if(!isObject(TezRP_64x64))
{
	datablock decalData(TezRP_64x64)
	{
		textureName = "Add-Ons/TezMods_CityRP/BuildZoneIcons/64x64LotIcon";
		preload = true;
	};
}

if(!isObject(TezRP_32x32_NoTax))
{
	datablock decalData(TezRP_32x32_NoTax)
	{
		textureName = "Add-Ons/TezMods_CityRP/BuildZoneIcons/32x32ZoneIcon";
		preload = true;
	};
}

package armorDamageOverride
{
	function Armor::damage(%this, %obj, %sourceObject, %position, %damage, %damageType)
	{
		if(%obj.getDatablock().isHealthPlayer)
		{
			%curEnergy = %obj.getEnergyLevel();
			
			if(%damage >= %curEnergy)
			{
				%obj.setEnergyLevel(0);
				%damage -= %curEnergy;
			}
			else
			{
				%obj.setEnergyLevel(%curEnergy - %damage);
				%damage = 0;
			}
			
			Parent::damage(%this, %obj, %sourceObject, %position, %damage, %damageType);
			
			if(%obj.getDatablock().isShieldedPlayer && %damage < %curEnergy)
			{
				%obj.emote(shieldZapImage);
			}
			else
			{
				if(%obj.getEnergyLevel() < %obj.maxEnergy / 2)
				{
					%obj.emote(painMidImage, 1);
				}
				if(%obj.getEnergyLevel() < %obj.maxEnergy / 3)
				{
					%obj.emote(painHighImage, 1);
				}
			}
		}
		else
		{
			Parent::damage(%this, %obj, %sourceObject, %position, %damage, %damageType);
		}
	}
};
ActivatePackage(armorDamageOverride);

datablock PlayerData(PlayerStandardHealth : PlayerStandardArmor)
{
	// Run Data
		runForce = 48 * 90;
		runEnergyDrain = 0;
		minRunEnergy = 0;

	// Walk Data
		maxForwardSpeed = 7;
		maxBackwardSpeed = 4;
		maxSideSpeed = 6;

	// Crouch Data
		maxForwardCrouchSpeed = 3;
		maxBackwardCrouchSpeed = 2;
		maxSideCrouchSpeed = 2;

	// Jump Data
		jumpForce = 12 * 90;
		jumpEnergyDrain = 0;
		minJumpEnergy = 0;
		jumpDelay = 3;

	// Jet Data
		minJetEnergy = 0;
		jetEnergyDrain = 0;
		canJet = 1;

	// Other Data
		uiName = "Regenerating Player";
		runSurfaceAngle  = 70;
		jumpSurfaceAngle = 80;
		showEnergyBar = 1;
		isHealthPlayer = 1;

	// Stats Data
		// Remember: The energy is, in essence, the health. Set this number to what you want the HP to be.
		maxEnergy = 100;
		// If you want to create an armor that has unrecoverable damage, set this above 1. Right now it is made so that any overflowing damage will instantly kill you.
		maxHealth = 1;
		// The recharge rate is, obviously, how fast energy regenerates. Right now it is pretty slow. You may increase it if you want.
		rechargeRate = 0.04;
};

//no jets and extra items
datablock PlayerData(PlayerNoJet7I : PlayerStandardHealth)
{
	minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;

	uiName = "No.Jet.7Item.Health";
	showEnergyBar = true;
	maxTools = 9;
   	maxWeapons = 9;
};
/////////////////////
///LUMBER START//
/////////////////

function fxDTSBrick::onCut(%this, %client)
{
	if(getJob(%client) $= "Lumberjack")
	{
			if(mFloor(getRandom(0, 100)) >= 80)
			{
				commandToClient(%client, 'centerPrint' , "\c6Lumber obtained.", 1);

				TezRPData.getData(%client.bl_id).valueLumber += 1;
				
				%client.TezRp(1);
			}
	}
	else
	{
		commandToClient(%client, 'centerPrint', "\c6Only Lumberjacks may cut these.", 3);
	}
}

package TezRP_LumberjackPackage
{
	function ProjectileData::onCollision(%this, %obj, %col, %fade, %pos, %normal)
	{		
		if(isObject(%col))
		{
			if(%col.getType() & $TypeMasks::FxBrickObjectType)
			{
				if(%col.getDatablock().getName() $= "TezRPTreeData")
				{
					if(%obj.getDatablock().getName() $= "TezRPLumberjackProjectile")
					{
						%col.onCut(%obj.sourceObject.client);
					}
				}
				
				parent::onCollision(%this, %obj, %col, %fade, %pos, %normal);
				return;
			}
		}
	}
};
activatePackage(TezRP_LumberjackPackage);



package LockPickPackage
{
	function LockPickProjectile::onCollision(%projectile, %obj, %col, %fade, %pos, %normal)
	{
		serverPlay3D(wrenchHitSound, %pos);
		%client = %obj.sourceObject.client;
		
		if((%col.getType() && $typeMasks::fxBrickObjectType))
		{
			if(striPos(%col.dataBlock, "Door") >=1)
       			{
				%col.doorOpen();

				commandToClient(%obj.client, 'centerPrint', "\c6You have commited a crime. [\c3Breaking and Entering\c6]", 1);

				%obj.client.TezRP(2, $TezRP::demerits::attemptedmurder);
			}

			parent::onCollision(%this, %obj, %col, %fade, %pos, %normal, %Client);
			return;
		}


	}
};
activatePackage(LockPickPackage);

//BATON START
///////////////

function fxDTSBrick::BrutalBatonOpenDoor(%brick, %client)
{
 // Is door
 if (!isObject(%brick.shape))
  return 1;
 
 // Cannot open admin doors
// if (getBrickGroupFromObject(%brick).client.isAdmin)
//  return 0;
 
 // JVS hack
 if (%brick.isContentBlocked(%client, 1, "CW") <= 0)
 {
  %brick.contentUse(%client, 0, "START", "CW");
  %brick.schedule(3000, "contentUse", %client, 0, "STOP", "CW");
 }
 else if (%brick.isContentBlocked(%client, 1, "CCW") <= 0)
 {
  %brick.contentUse(%client, 0, "START", "CCW");
  %brick.schedule(3000, "contentUse", %client, 1, "STOP", "CCW");
 }
 else
 {
  return 0;
 }
 
 return 1;
}

function fxDTSBrick::onBatonOpen(%brick, %client)
{
 if (!isObject(%brick.shape))
  return;
 
 if (!%brick.BrutalBatonOpenDoor(%client))
  commandToClient(%client, 'centerPrint', "\c6The door is batonproof.", 2);
}

function fxDTSBrick::onBatonStrike(%brick, %client)
{
 if (!isObject(%brick.shape))
  return;

if (%brick.BrutalOpenDoor(%client))
 {
	echo("poor door...");
 }
}
        function TezRPBatonImage::onFire(%this, %obj, %slot)
        {
                parent::onFire(%this, %obj, %slot);
                
                %obj.playThread(2, "armAttack");
        }
        
        function TezRPBatonImage::onStopFire(%this, %obj, %slot)
        {
                %obj.playThread(2, "root");

        }

package TezRPBaton
{

        function TezRPBatonProjectile::onCollision(%this, %obj, %col, %fade, %pos, %normal, %client)
        {
                serverPlay3D(hammerHitSound, %pos);
                %client = %obj.sourceObject.client;
	
		if((%col.getType() & $typeMasks::fxBrickObjectType))
		{		
			if(striPos(%col.dataBlock, "Door") >=1)
       			{             		 	
				%col.doorOpen();
			}
			parent::onCollision(%this, %obj, %col, %fade, %pos, %normal, %Client);
			return;
		}

                if((%col.getType() & $typeMasks::playerObjectType) && isObject(%col.client))
                {
                        if(TezRPData.getData(%col.client.bl_id).valueDemerits < $TezRP::demerits::wantedLevel)
                        {
                               
				commandToClient(%obj.client, 'centerPrint', "\c3" @ %col.client.name SPC "\c6is not wanted!", 1);
				
                        	return;
                        }
                        
                        if(TezRPData.getData(%col.client.bl_id).valueDemerits >= $TezRP::demerits::wantedLevel)
                        {
                                if(%col.client.isGod == true)
                                {
                                        return; 
                                }

				%jailchance = getRandom(1, 5);

				if(%jailchance == 5)
				{
					%col.client.TezRP(3, %obj.client);
				}
			
				//%col.client.addhealth("-5");

				//if(%col.client.getDamageLevel() < 50)
				//{
					//echo("Health Check");
                                	//%col.client.TezRP(3, %obj.client);
				//}

                        }
                        return;
                }
        }
};
activatePackage(TezRPBaton);

//players on FIRE!!
datablock ShapeBaseImageData(playerOnFireImage)
{
   	shapeFile = "base/data/shapes/empty.dts";
	emap = false;

	mountPoint = $HeadSlot;
	offset = "0 0 -2";

	stateName[0]					= "Ready";
	stateTransitionOnTimeout[0]			= "FireA";
	stateTimeoutValue[0]				= 0.01;

	stateName[1]					= "FireA";
	stateTransitionOnTimeout[1]			= "Done";
	stateWaitForTimeout[1]				= True;
	stateTimeoutValue[1]				= 1.0;
	stateEmitter[1]					= burnemittera;
	stateEmitterTime[1]				= 1.0;

	stateName[2]					= "Done";
	stateTransitionOnTimeout[2]			= "FireA";
	stateTimeoutValue[2]				= 0.01;
};

package TezRPFireStuff
{
	function firewandProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
		if(isobject(%obj.client.minigame))
		{
   			if(%col.getclassname()$=fxDTSbrick && !%col.fireclient)
			{
				if(!%brick.isfireminigame)
				{
					%fireCatchchance = getRandom(1, 50);

					if(%fireCatchchance == 50)
					{ 
						servercmdstartfire(%obj.client,%col);
					
						//commandToClient(%obj.client, 'centerPrint', "\c6You have commited a crime. [\c3Arson\c6]", 1);
                                		//%obj.client.TezRP(2, $TezRP::demerits::attemptedmurder);
					}
   				}
			}
			
			else if(%col.getclassname()$="Player")
			{
    				startFirePlayer(%col);
			}
  
		}
		
		else
		{
			messageclient(%obj.client,'',"You are not in a minigame.");
		}
}

//function startfireplayer(%obj)
//{
	//if(%obj.fireminigame)
	//{
	//	return;
	//}
//	%obj.fireminigame=%obj.client.minigame;
//	%obj.emote(playeronfireimage);
//	%obj.damage(%obj,%obj,getrandom(10,20));
//	schedule(1000,0,continuefireplayer,%obj);
//}

function continuefireplayer(%obj)
{
	//if(!%obj.fireminigame || !isobject(%obj))
	//{
	//	return;
	//}

	if(!getrandom(0,4))
	{
		%obj.fireminigame=0;
		return;
 	}

	%obj.emote(playeronfireimage);
	%obj.damage(%obj,%obj,getrandom(10,20));
	schedule(1000,0,continuefireplayer,%obj);
}

function firehoseProjectile::onCollision(%this,%obj,%col,%pos,%fade)
{
	if(%col.getclassname()$="Player" && %col.fireminigame)
	{
  		%col.fireminigame=0;
	}

	else if(%col.isfireminigame == true)
	{
  		%col.water++;
  	
		if(%col.water >= $minWaterToExtinguish)
		{
   			if(isobject(%col.emitter))
			{
    				%col.setemitter(None);
   				%col.setlight(0);
   				%col.isfireminigame = false;
				//cancel($brick.fireSpreadSched);
				//cancel($brick.scorchSched);
				//cancel($brick.fireDestroySched);
   				//%obj.client.incscore(1);

				if(getJob(%obj.client) $= "Fire Fighter")
        			{
					TezRPData.getData(%obj.client.bl_id).valueMoney += 20;
					messageClient(%obj.client, '', "\c5Fire Fighting: +$20!");
					%obj.client.tezrp(1);
				}
			}
  		}
 	}
	Parent::onCollision(%this,%obj,%col,%pos,%fade);
}

};
activatePackage(TezRPFireStuff);
