///////////////////////////////////////////////////////////////////////////////////////
//FIRE Extinguisher Model from Diggy's Metropolis RP, code from Zor's Fire fight Mod//
/////////////////////////////////////////////////////////////////////////////////////
datablock ParticleData(firehoseExplosionParticle)
{
	dragCoefficient      = 2;
	gravityCoefficient   = 0.1;
	windCoefficient	   = 1;
	inheritedVelFactor   = 0.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 600;
	lifetimeVarianceMS   = 200;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 100.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.7 0.7 0.9 0.9";
   	colors[1]     = "0.9 0.9 0.9 0.0";

	sizes[0]      = 1;
	sizes[1]      = 1.4;

	times[0]	  = 2;
	times[1]	  = 2;


	useInvAlpha = false;
};
datablock ParticleEmitterData(firehoseExplosionEmitter)
{
   ejectionPeriodMS = 40;
   periodVarianceMS = 0;
   ejectionVelocity = 3.5;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 35;
   thetaMax         = 85;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   orientOnVelocity = true;
   particles = "firehoseExplosionParticle";
};

datablock ExplosionData(firehoseExplosion)
{
   lifeTimeMS = 128;

   particleEmitter = firehoseExplosionEmitter;
   particleDensity = 10;
   particleRadius = 1;
   explosionScale = "1 1 1";
};

datablock ParticleEmitterData(firehoseTrailEmitter)
{
	ejectionPeriodMS = 5;
	periodVarianceMS = 5;
	ejectionVelocity = 0; //0.25;
	velocityVariance = 0; //0.10;
	ejectionOffset   = 0.1;
	thetaMin         = 0.0;
	thetaMax         = 90.0;  
	phiReferenceVel  = 0;
	phiVariance      = 360;
	overrideAdvance = false;
	particles = firehoseTrailParticle;
};

datablock ParticleData(firehoseTrailParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 300;
	lifetimeVarianceMS	= 50;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= true;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/cloud";

	// Interpolation variables
	colors[0]	= "0.996 0.996 0.910 0.500";
	colors[1]	= "0.996 0.996 0.910 0.000";
	sizes[0]	= 0.5;
	sizes[1]	= 0.7;
	times[0]	= 0.0;
	times[1]	= 1.0;
};

datablock ProjectileData(firehoseProjectile)
{
   directDamage        = 0;
   directDamageType = $DamageType::sword;
   explosion           = firehoseExplosion;
   //ParticleEmitter = firehoseTrailEmitter

   muzzleVelocity      = 100;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 200;
   fadeDelay           = 0;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;
};

//////////
// item //
//////////
datablock ItemData(firehoseItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./FireExtinguisher.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Fire Extinguisher";
	doColorShift = true;
	colorShiftColor = "0.0 0.500 0.100 1.000";

	 // Dynamic properties defined by the scripts
	image = firehoseImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(firehoseImage)
{
   // Basic Item properties
   shapeFile = "./FireExtinguisher.dts";
   emap = true;

   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0;
   rotation = "1 0 0 0";
   correctMuzzleVector = true;
   className = "WeaponImage";

   // Projectile && Ammo.
   item = firehoseItem;
   ammo = " ";
   projectile = firehoseProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doRetraction = false;

   doColorShift = true;
   colorShiftColor = firehoseItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTransitionOnTriggerDown[0]  = "Fire";
	stateAllowImageChange[0]	   = true;
	stateSound[0]			   = sprayActivateSound;
	stateTransitionOnTimeout[0]	   = "Ready";
	stateTimeoutValue[0]		   = 0.01;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateTimeoutValue[1]		   = 0.04;
	stateTransitionOnTimeout[1]	   = "Ready";
	stateWaitForTimeout[1]		   = true;
	stateAllowImageChange[1]	   = true;
	stateEmitterTime[1]		   = 0.07;

	stateName[2]                     = "Fire";
	stateTransitionOnTriggerUp[2]	   = "StopFire";
	stateTransitionOnTimeout[2]	   = "Fire";
	stateTimeoutValue[2]		   = 0.04;
	stateWaitForTimeout[2]		   = true;
	stateFire[2]			   = true;
	stateAllowImageChange[2]	   = true;
	stateSound[2]			   = sprayFireSound;
	stateScript[2]			   = "onFire";
	stateEmitter[2]			   = firehoseEmitter;
	stateEmitterTime[2]		   = 0.07;
	stateSequence[2]			   = "fire";

	stateName[3] 			   = "StopFire";
	stateTransitionOnTimeout[3]	   = "Ready";
	stateWaitForTimeout[3]		   = true;
	stateAllowImageChange[3]	   = true;
	stateSequence[3]			   = "stopfire";
};