////////////////////////////////////////////////////////////////////
//M2 Flame Thrower by Stratofortress adapted for TezRP fire fight//
//////////////////////////////////////////////////////////////////


//exec("add-ons/Particle_Basic/Particle_Basic.cs");

datablock ParticleData(FireWandParticle)
{
	dragCoefficient      = 2.9;
	gravityCoefficient   = 0.1;
	inheritedVelFactor   = 1.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 600;
	lifetimeVarianceMS   = 200;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]	= "1   1   0.3 0.0";
	colors[1]	= "1   1   0.3 1.0";
	colors[2]	= "0.6 0.0 0.0 0.0";
   	colors[3]     = "0 0 0 0";

	sizes[0]      = 0.5;
	sizes[1]      = 1.0;
 	sizes[2]      = 2;
 	sizes[3]      = 2;

   	times[0] = 0;
   	times[1] = 1;
   	times[2] = 2;
  	times[3] = 2;

	useInvAlpha = false;
};

datablock ParticleEmitterData(FireWandEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 80;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 2;
   phiReferenceVel  = 200;
   phiVariance      = 360;
   overrideAdvance = false;
   orientOnVelocity = true;
   particles = "FireWandParticle";
};




datablock ParticleData(FireWandExplosionParticle)
{
	dragCoefficient      = 2;
	gravityCoefficient   = 0.0;
	windCoefficient	   = 1;
	inheritedVelFactor   = 0.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 600;
	lifetimeVarianceMS   = 200;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 200.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "1.000000 0.496063 0.000000 0.496063";
	colors[1]     = "1.000000 0.496063 0.000000 0.000000";
	colors[2]     = "1.000000 1.000000 1.000000 1.000000";
	colors[3]     = "1.000000 1.000000 1.000000 1.000000";
	sizes[0]      = 0.799609;
	sizes[1]      = 1.19636;
	sizes[2]      = 1;
	sizes[3]      = 1;
	times[0]	  = 0;
	times[1]	  = 1;
	times[2]	  = 2;
	times[3]	  = 2;

	useInvAlpha = false;
};
datablock ParticleEmitterData(FireWandExplosionEmitter)
{
   ejectionPeriodMS = 40;
   periodVarianceMS = 0;
   ejectionVelocity = 3.5;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 35;
   thetaMax         = 85;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   orientOnVelocity = true;
   particles = "FireWandExplosionParticle";
};
datablock DebrisData(fireTFDebris)
{
   emitters = "BurnEmitterA";

	shapeFile = "base/data/shapes/empty.dts";
	lifetime = 3.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.4;
	friction = 0.3;
	numBounces = 3;
	staticOnMaxBounce = false;
	snapOnMaxBounce = true;
	fade = true;


	gravModifier = 2;
};
datablock ExplosionData(FireWandExplosion)
{
   lifeTimeMS = 128;

   //particleEmitter = FireWandExplosionEmitter;
   particleDensity = 10;
   particleRadius = 1;
   explosionScale = "1 1 1";

   
   playerBurnTime = 8000;
   
         debris = fireTFDebris;
   debrisNum = 2;
   debrisNumVariance = 0;
   debrisPhiMin = 0;
   debrisPhiMax = 360;
   debrisThetaMin = 10;
   debrisThetaMax = 50;
   debrisVelocity = 5;
   debrisVelocityVariance = 1;
   

};


AddDamageType("FireWandDirect",   '<bitmap:add-ons/TezMods_CityRP/Items/FlameThrower/ci_fire> %1',    '%2 <bitmap:add-ons/TezMods_CityRP/Items/FlameThrower/ci_fire> %1',1,1);
AddDamageType("FireWandradius",   '<bitmap:add-ons/TezMods_CityRP/Items/FlameThrower/ci_fire> %1',    '%2 <bitmap:add-ons/TezMods_CityRP/Items/FlameThrower/ci_fire> %1',1,1);
datablock ProjectileData(FireWandProjectile)
{
   directDamage        = 900;
      damageRadius =0;
   radiusDamage =900;
   directDamageType = $DamageType::FireWandDirect;
      radiusDamageType = $DamageType::FireWandradius;
   explosion           = FireWandExplosion;
   particleEmitter = BurnemitterA;

   muzzleVelocity      = 150;
   velInheritFactor    = 0;

   armingDelay         = 0;
   lifetime            = 250;
   fadeDelay           = 0;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = true;
   gravityMod = 1.0;
   
   
};



//////////
// item //
//////////
datablock ItemData(FireWandItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./m2.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "M2 Flamethrower";
	iconName = "./icon_FireWand";
	doColorShift = true;
	colorShiftColor = "1 1 1 1.000";

	 // Dynamic properties defined by the scripts
	image = FireWandImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(FireWandImage)
{
   // Basic Item properties
   shapeFile = "./m2.dts";
   emap = true;

   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = "0 0.7 -2.2";
   rotation = "1 0 0 0";
   correctMuzzleVector = true;
   className = "WeaponImage";

   // Projectile && Ammo.
   item = FireWandItem;
   ammo = " ";
   projectile = FireWandProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doRetraction = false;

   doColorShift = true;
   colorShiftColor = "0.15 0.15 0.15 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	//stateTransitionOnTriggerDown[0]  = "Fire";
	//statescript[0]		=    "checkammo";
		stateWaitForTimeout[0]		   = true;
	stateAllowImageChange[0]	   = true;
	stateSound[0]			   = sprayActivateSound;
	stateTransitionOnTimeout[0]	   = "Ready";

	stateTimeoutValue[0]		   = 0.01;

	stateName[1]                     = "Ready";

	stateTransitionOnTriggerDown[1]  = "Fire";
	statescript[1]		=    "checkammo";
	stateAllowImageChange[1]	   = true;


	stateName[2]                     = "Fire";
	stateTransitionOnTriggerUp[2]	   = "ready";
	stateTransitionOnTimeout[2]	   = "Fire";
	stateTimeoutValue[2]		   = 0.01;
	stateWaitForTimeout[2]		   = true;
	stateFire[2]			   = true;
	stateAllowImageChange[2]	   = true;
	stateSound[2]			   = sprayFireSound;
	stateScript[2]			   = "onFire";
	stateEmitter[2]       = FireWandemitter;
	statetransitionOnNoAmmo[2]      = "noammo";
	stateEmitterTime[2]		   = 0.07;
	stateSequence[2]			   = "fire";

	stateName[3] 			   = "noammo";
	stateScript[3]			   = "ondone";
		


};

package TezRPFlameThrower
{

//function FireWandProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
//{
//   	%player = %obj;
//   	%client = %obj.client;
//
// 	if(isObject(%player.client.minigame))
//	{
//
   		//continuousDamage(%obj,%pos,%this.damageRadius,%this.radiusDamage,%this.RadiusDamageType,0,10000);
		//return;
//		parent::onCollision(%this,%obj,%col,%fade,%pos,%normal);
//	}
//}
function continuousDamage(%sourceObject, %position, %radius, %damage, %damageType, %impulse,%duration)
{


		radiusDamage(%sourceObject, %position, %radius, %damage, %damageType, %impulse);
		if (%duration<0) return;
		schedule(200,0,continuousDamage,%sourceObject, %position, %radius, %damage, %damagetype, %impulse,%duration-500);

}
function radiusDamage(%sourceObject, %position, %radius, %damage, %damageType, %impulse)
{
   // Use the container system to iterate through all the objects
   // within our explosion radius.  We'll apply damage to all ShapeBase
   // objects.
   InitContainerRadiusSearch(%position, %radius, $TypeMasks::ShapeBaseObjectType);

   %halfRadius = %radius / 2;
   while ((%targetObject = containerSearchNext()) != 0) {

      // Calculate how much exposure the current object has to
      // the explosive force.  The object types listed are objects
      // that will block an explosion.  If the object is totally blocked,
      // then no damage is applied.
      %coverage = calcExplosionCoverage(%position, %targetObject,
         $TypeMasks::InteriorObjectType |  $TypeMasks::TerrainObjectType |
         $TypeMasks::ForceFieldObjectType | $TypeMasks::VehicleObjectType);
      if (%coverage == 0)
         continue;

      // Radius distance subtracts out the length of smallest bounding
      // box axis to return an appriximate distance to the edge of the
      // object's bounds, as opposed to the distance to it's center.
      %dist = containerSearchCurrRadiusDist();

      // Calculate a distance scale for the damage and the impulse.
      // Full damage is applied to anything less than half the radius away,
      // linear scale from there.
      %distScale = (%dist < %halfRadius)? 1.0:
         1.0 - ((%dist - %halfRadius) / %halfRadius);

      // Apply the damage
      %targetObject.damage(%sourceObject, %position, %damage * %coverage * %distScale, %damageType);

      // Apply the impulse
      if (%impulse) {
         %impulseVec = VectorSub(%targetObject.getWorldBoxCenter(), %position);
         %impulseVec = VectorNormalize(%impulseVec);
         %impulseVec = VectorScale(%impulseVec, %impulse * %distScale);
         %targetObject.applyImpulse(%position, %impulseVec);
      }
   }
}

function FireWandImage::onfire(%this,%obj,%slot)
{


	
	%player = %obj;


		    %obj.setimageammo(%slot,1);
		%obj.ammo["FireWand"]-=1;
	
		%projectile = FireWandprojectile;
		%spread = 0.01;
		%shellcount = 1;
	



		for(%shell=0; %shell<%shellcount; %shell++)
		{
			%vector = %obj.getMuzzleVector(%slot);
			%objectVelocity = %obj.getVelocity();
			%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
			%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
			%velocity = VectorAdd(%vector1,%vector2);
			%x = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
			%y = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
			%z = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
			%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
			%velocity = MatrixMulVector(%mat, %velocity);

			%p = new (%this.projectileType)()
			{
				dataBlock = %projectile;
				initialVelocity = %velocity;
				initialPosition = %obj.getMuzzlePoint(%slot);
				sourceObject = %obj;
				sourceSlot = %slot;
				client = %obj.client;
			};
			MissionCleanup.add(%p);
		

		
	}
	return %p;

}

};
activatePackage(TezRPFlameThrower);